library ruDWGPreviewNew;

uses
  SysUtils,
  Classes,
  Windows,
  listplug,
  dwgThumbnail,
  uMisc in 'uMisc.pas',
  uMain in 'uMain.pas' {fmViewerMain};

{$E wlx}
{$R *.res}

const
  DetectStr: AnsiString = 'ext="DWG"';

procedure ListGetDetectString(DetectString: PAnsiChar; MaxLen: integer); stdcall;
begin
  StrLCopy(DetectString, PAnsiChar(DetectStr), MaxLen - 1);
end;

function ListLoadW(ListerWin: HWND;FileToLoad:pwidechar;ShowFlags:integer):thandle; stdcall;
begin
  Result := ShowImageForm(ListerWin, FileToLoad, False);
end;

function ListLoad(ListerWin: HWND; FileToLoad: PAnsiChar; ShowFlags: integer): HWND; stdcall;
begin
  Result := ListLoadW(ListerWin, PWideChar(FileToLoad), ShowFlags);
end;

procedure ListCloseWindow(ListerWin: HWND); stdcall;
begin
  HideImageForm(ListerWin);
end;

function ListLoadNextW(ListerWin,PluginWin:thandle;FileToLoad:pwidechar;ShowFlags:integer):integer; stdcall;
var
  p: ^TPlugInfo;
begin
  Result := LISTPLUGIN_ERROR;
  p := Pointer(GetWindowLong(PluginWin, GWL_USERDATA));
  if p^.PlugForm.GlobalLoadNextImage(FileToLoad) then Result := LISTPLUGIN_OK;
end;

function ListLoadNext(ListerWin,PluginWin:thandle;FileToLoad:pansichar;ShowFlags:integer):integer; stdcall;
begin
  Result := ListLoadNextW(ListerWin, PluginWin, PWideChar(FileToLoad), ShowFlags);
end;

function ListGetPreviewBitmapW(FileToLoad:pwidechar;width,height:integer;
    contentbuf:pansichar;contentbuflen:integer):hbitmap; stdcall;
begin
  try
    Result := GetBitmapForThumb(FiletoLoad, Width, Height);
  except
    Result := 0;
  end;
end;

function ListGetPreviewBitmap(FileToLoad:pansichar;width,height:integer;
    contentbuf:pansichar;contentbuflen:integer):hbitmap; stdcall;
begin
  Result := ListGetPreviewBitmapW(PWideChar(FileToLoad), width, height, contentbuf, contentbuflen);
end;

exports
  ListGetDetectString,
  ListLoad,
  ListLoadW,
  ListGetPreviewBitmap,
  ListGetPreviewBitmapW,
  ListCloseWindow;

procedure DllInit(Code: integer);
begin
  case Code of
    DLL_PROCESS_ATTACH:
      begin
      end;
    DLL_PROCESS_DETACH:
      begin
      end;
  end; // case
end;

begin
  DllProc := @DllInit;
  DllInit(DLL_PROCESS_ATTACH);
end.
